`bubble.arma` <-
function(obj,#Objeto do tipo arma
                        bairro,#Bairro
                        data=1,#Posio da Data
                        grupo=1,#Grupo
                        text=FALSE)#Plotar nomes das armadilhas
{
  Total <- tapply(obj$resp[[bairro]][[data]][[grupo]]$NRO[!is.na(obj$resp[[bairro]][[data]][[grupo]]$NRO)], obj$resp[[bairro]][[data]][[grupo]]$COD[!is.na(obj$resp[[bairro]][[data]][[grupo]]$NRO)], mean, na.rm=T)
  x <- coordinates(obj$pts[obj$pts$ID %in% names(Total),])[,1]
  y <- coordinates(obj$pts[obj$pts$ID %in% names(Total),])[,2]
  az <- abs(Total)
  q <- sqrt(quantile(Total))
  cex <- as.vector(3 * az/max(az, q))
  codbairro <- c(40, 94, 73, 55, 51)
  names(codbairro) <- c("DI", "BT", "EM", "CFP", "MCP")
  plot(obj$poly[[codbairro[names(codbairro)==bairro]]], asp=1, type="l", main="", axes=FALSE,xlab="",ylab="")
  points(x, y, asp=1, cex=cex, col="green", pch=16)
  if(text)text(x-20,y-20, substr(names(Total), 3,6), cex=0.6)
}

