`kfademaps` <-
function(mapas,ntrans,zlim=c(0,0),contorno,paleta=terrain.colors(20), env=parent.frame(), ...){

TAM <- length(mapas)

if (zlim[1]==0 && zlim[2]==0) {
  maximo <- rep(0,TAM)
  minimo <- maximo
    for (x in 1:TAM) {
      maximo[x] <- max(eval(as.name(mapas[x]), envir=env)$z,na.rm=T)
      minimo[x] <- min(eval(as.name(mapas[x]), envir=env)$z,na.rm=T)
    }
  zlim <- c(min(minimo),(max(maximo)))
}

for (x in 1:(TAM-1)) {
  nf <- layout(matrix(c(1,2), nrow=2, byrow=T),width=c(8,1), hei=c(10,1))
    kfade(eval(as.name(mapas[x]), envir=env),eval(as.name(mapas[x+1]), envir=env),ntrans=ntrans,paleta=paleta,borda=contorno,zlimite=zlim,tit=mapas[x], ...)
  par(mar=c(1.1,4.1,.1,2.1))
  plot(c(0,0),ylim=c(0,1), xlim=c(0,TAM-1), type="n", axes=F, xlab="", ylab="")
  rect(-0.98,0,x, 1, density=100, col="blue", border="blue")
  dev.next()
}
}

