\name{smooth.arma}
\alias{smooth.arma}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ ~~function to do ... ~~ }
\description{
  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
smooth.arma(obj, bairro, data = 1, grupo = 1, grau = 100, log = TRUE, points = FALSE, contour = FALSE, method = c("gam", "loess", "akima", "tps", "mba", "lm", "glm"), plot = TRUE, statistics = FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{obj}{ ~~Describe \code{obj} here~~ }
  \item{bairro}{ ~~Describe \code{bairro} here~~ }
  \item{data}{ ~~Describe \code{data} here~~ }
  \item{grupo}{ ~~Describe \code{grupo} here~~ }
  \item{grau}{ ~~Describe \code{grau} here~~ }
  \item{log}{ ~~Describe \code{log} here~~ }
  \item{points}{ ~~Describe \code{points} here~~ }
  \item{contour}{ ~~Describe \code{contour} here~~ }
  \item{method}{ ~~Describe \code{method} here~~ }
  \item{plot}{ ~~Describe \code{plot} here~~ }
  \item{statistics}{ ~~Describe \code{statistics} here~~ }
  \item{\dots}{ ~~Describe \code{\dots} here~~ }
}
\details{
  ~~ If necessary, more details than the description above ~~
}
\value{
  ~Describe the value returned
  If it is a LIST, use
  \item{comp1 }{Description of 'comp1'}
  \item{comp2 }{Description of 'comp2'}
  ...
}
\references{ ~put references to the literature/web site here ~ }
\author{ ~~who you are~~ }
\note{ ~~further notes~~ 

 ~Make other sections like Warning with \section{Warning }{....} ~
}
\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function(obj,  #Objeto da Classe arma
                        bairro,                 #Bairro na forma "BT", "DI", etc
			data=1,                 #Posicao da data - veja names(resp), ou Data no formato "YYYY-MM"
			grupo=1,                #Grupo, na forma 1:4
			grau=100,               #Grau de suavizacao
			log=TRUE,               #Usar logaritmo
			points=FALSE,           #Plotar pontos
			contour=FALSE,          #Contorno
			method=c("gam", "loess", "akima", "tps", "mba","lm", "glm"), #Metodo
			plot=TRUE,              #Plotar o grafico
                        statistics=FALSE,       #Retornar Anlises do model
                        ...)                    #Argumentos passados para outros metodos
                        
{

codbairro <- list(BT=94, CFP=c(54,55), DI=c(39,40), EM=73, MCP=c(51,52))
cod <- codbairro[[bairro]]
bairro.name <- switch(bairro,
                      BT="Brasilia Teimosa",
                      EM="Engenho do Meio",
                      DI="Dois Irmos",
                      CPF="Casa Forte",
                      MCP="Morro da Conceicao")

if(!method \%in\% c("gam", "loess", "akima", "tps", "mba","lm", "glm"))stop("\nMetodo no disponvel")
if(!grupo \%in\% names(obj$resp[[bairro]][[data]]))stop("\nNao ha observacoes deste grupo na data especificada")

if(log){
	.resp <- tapply(log(obj$resp[[bairro]][[data]][[grupo]]$NRO[!is.na(obj$resp[[bairro]][[data]][[grupo]]$NRO)]+.5), obj$resp[[bairro]][[data]][[grupo]]$COD[!is.na(obj$resp[[bairro]][[data]][[grupo]]$NRO)], mean, na.rm=T)
	}else{
	.resp <- tapply(obj$resp[[bairro]][[data]][[grupo]]$NRO[!is.na(obj$resp[[bairro]][[data]][[grupo]]$NRO)], obj$resp[[bairro]][[data]][[grupo]]$COD[!is.na(obj$resp[[bairro]][[data]][[grupo]]$NRO)], mean, na.rm=T)
  }

x <- coordinates(obj$pts[obj$pts$ID \%in\% names(.resp),])[,1]
y <- coordinates(obj$pts[obj$pts$ID \%in\% names(.resp),])[,2]

# Gerando o Grid #
boxbairro <- bbox(do.call("rbind", obj$poly[cod]))
gx <- seq(boxbairro[1], boxbairro[3], l=grau)
gy <- seq(boxbairro[2], boxbairro[4],l=grau)
grd <- expand.grid(x=gx, y=gy)
#Teste
grd1 <- cbind(x, y)
#Borda
borda <- do.call("rbind", obj$poly[cod])


if(length(.resp)<19){
    formula<-as.formula(.resp~s(x, y, k=length(.resp)))
  }else{
    formula<-as.formula(.resp~s(x)+s(y))
  }

ajust <- switch(method, 
	gam=gam(formula,...),
	loess=loess(.resp ~ x+y, control=loess.control(surface="direct"),...),
	akima=interp.new(x,y,.resp,
              xo=seq(min(x), max(x), length = grau),
              yo=seq(min(y), max(y), length = grau),
              linear=FALSE, extrap=TRUE ,
              duplicate="error", dupfun=NULL , ncp=NULL),
        tps=Tps(as.data.frame(cbind(x, y)), .resp, ...),
        mba=mba.surf(cbind(x, y, .resp),grau, grau, extend=T, ...)$xyz.est ,
        lm=lm(.resp ~ poly(x,2) + poly(y,2), ...),
        glm=glm(.resp ~ x+y,...)
)


if(method=="gam"){
	pred <- matrix(predict(ajust,grd),grau,grau)
	pred[!.geoR_inout(grd,borda)]<- NA
        out <- cbind(.resp, predict(ajust, as.data.frame(grd1)))}
if(method=="loess"){
	pred <- predict(ajust, grd)
	pred[!.geoR_inout(grd, borda)] <- NA
        out <- cbind(.resp, predict(ajust, as.data.frame(grd1)))}
if(method=="akima"){
	pred <- ajust$z
	pred[!.geoR_inout(grd, borda)] <- NA}
if(method=="tps"){
  grid.l<- list(x=gx, y=gy)
  pred<-predict.surface(ajust, extrap=T, grid.list=grid.l)
  pred$z[!.geoR_inout(grd, borda)] <- NA
  pred <- pred$z}
if(method=="mba"){
  pred<-ajust$z
  pred[!.geoR_inout(grd, borda)] <- NA}
if(method=="lm"){
  pred <- predict(ajust, grd)
  dim(pred) <- c(grau,grau) 
  pred[!.geoR_inout(grd, borda)] <- NA
  out <- cbind(.resp, predict(ajust, as.data.frame(grd1)))
  }
if(method=="glm"){
  pred <- predict(ajust, grd)
  dim(pred) <- c(grau, grau)
  pred[!.geoR_inout(grd, borda)] <- NA
  out <- cbind(.resp, exp(predict(ajust, as.data.frame(grd1))))
  }
  
if(plot){
  def.par <- par(no.readonly = TRUE)
  on.exit(par(def.par))
  mat <- matrix(1:length(.resp), ncol=length(.resp))
  nf <- layout(matrix(c(1,1,2,3), ncol=2, byrow=T), width=c(5,1), hei=c(1,8))
  par(mar=c(0.1,0.1,0.1,0.1))
  ltitle(paste("Metodo: ", method,"\nData: ", names(obj$resp[[bairro]][data]), "\nGrupo: ", grupo, "\nBairro: ", bairro.name, sep=""),cex=1,ypos=1)
  box()
  lab <- round(seq(min(pred, na.rm=T), max(pred, na.rm=T), l=length(.resp)),1)
  par(mar=c(5.1,0.1,0.1,2))
     image(gx,gy,pred, asp=1, col=terrain.colors(length(.resp)),axes=F, xlab="", ylab="", main="")
	   lines(borda, lwd=2)
     if(points)points(x, y, pch="+")
     if(contour)contour(gx, gy, pred, add=T, lwd=1.5)
     par(mar=c(5.1,1.2,0.1,5))
	   image(mat, col=terrain.colors(length(.resp)), axes=F)
	   box()
     axis(4, at=seq(0,1, l=length(.resp)), labels=lab, font=2, las=TRUE, cex=0.5)
  }else{
  if(statistics){
    ret <- switch(method,
                  gam=list(AIC=AIC(ajust), Residuals=out),
                  glm=list(AIC=AIC(ajust), Residuals=out),
                  lm=list(AIC=AIC(ajust), Residuals=out),
                  loess=list(Residuals=out))
     return(ret) 
     }else{
  return(list(x=gx, y=gy, z=pred, coord.x=x, coord.y=y, bairro=bairro, grupo=grupo, data=data))
  }
  }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
